Unit sfg6e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, SF66E_p, UTSF13_p, SFG6E1_p;

function sfg6e(X :Extended; A :Extended; B :Extended; EPS :Extended;
                ITMAX :Integer; var IERR :Integer): Extended;

implementation

function sfg6e(X :Extended; A :Extended; B :Extended; EPS :Extended;
                ITMAX :Integer; var IERR :Integer): Extended;
var
BT,R1,R2,R3 :Extended;
const
SYS053 :Real = 1.7e308;
label
_10,_70,_20,_30,_40,_50,_60;
begin
{ Result -    SFG6E  FORTRANe }
IERR := 0;
if ( X >= 0.0e0 ) or ( X <= 1.0e0 ) 
 then goto _10;
IERR := 65;
goto _50;
_10:
if ( A > 0.0e0 ) and ( B > 0.0e0 ) 
 then goto _70;
IERR := 66;
goto _50;
_70:
if ( X <> 0.0e0 ) or ( X <> 1.0e0 ) 
 then goto _20;
BT := 0.0e0;
goto _30;
_20:
SF66E(A+B,R1,IERR);
SF66E(A,R2,IERR);
SF66E(B,R3,IERR);
BT := Exp(R1-R2-R3+A*Ln(X)+B*Ln(1.0e0-X));
_30:
if ( X >= (A+1.0e0)/(A+B+1.0e0) ) 
 then goto _40;
Result := BT*SFG6E1(X,A,B,EPS,ITMAX,IERR)/A;
if ( IERR <> 0 ) 
 then goto _50;
goto _60;
_40:
Result := 1.0e0-BT*SFG6E1(1.0e0-X,B,A,EPS,ITMAX,IERR)/B;
if ( IERR = 0 ) 
 then goto _60;
_50:
Result := SYS053;
UTSF13(IERR,52);
_60:
exit;
end;

end.
